diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/class-wp-xmlrpc-server.php ./wordpress-3.4/wp-includes/class-wp-xmlrpc-server.php
*** ./wordpress-3.3.2/wp-includes/class-wp-xmlrpc-server.php	2011-10-27 13:36:49.000000000 -0500
--- ./wordpress-3.4/wp-includes/class-wp-xmlrpc-server.php	2012-06-05 11:25:05.000000000 -0500
***************
*** 2385,2391 ****
  		$post_category = array();
  		if ( isset( $content_struct['categories'] ) ) {
  			$catnames = $content_struct['categories'];
- 			logIO('O', 'Post cats: ' . var_export($catnames,true));
  
  			if ( is_array($catnames) ) {
  				foreach ($catnames as $cat) {
--- 3857,3862 ----
***************
*** 2409,2414 ****
--- 3880,3892 ----
  		if ( isset($content_struct['custom_fields']) )
  			$this->set_custom_fields($post_ID, $content_struct['custom_fields']);
  
+ 		if ( isset ( $content_struct['wp_post_thumbnail'] ) ) {
+ 			if ( set_post_thumbnail( $post_ID, $content_struct['wp_post_thumbnail'] ) === false )
+ 				return new IXR_Error( 404, __( 'Invalid attachment ID.' ) );
+ 
+ 			unset( $content_struct['wp_post_thumbnail'] );
+ 		}
+ 
  		// Handle enclosures
  		$thisEnclosure = isset($content_struct['enclosure']) ? $content_struct['enclosure'] : null;
  		$this->add_enclosure_if_new($post_ID, $thisEnclosure);
***************
*** 2427,2433 ****
  		if ( !$post_ID )
  			return new IXR_Error(500, __('Sorry, your entry could not be posted. Something wrong happened.'));
  
! 		logIO('O', "Posted ! ID: $post_ID");
  
  		return strval($post_ID);
  	}
--- 3905,3911 ----
  		if ( !$post_ID )
  			return new IXR_Error(500, __('Sorry, your entry could not be posted. Something wrong happened.'));
  
! 		do_action( 'xmlrpc_call_success_mw_newPost', $post_ID, $args );
  
  		return strval($post_ID);
  	}
***************
*** 2485,2537 ****
  
  		$this->escape($args);
  
! 		$post_ID     = (int) $args[0];
! 		$username  = $args[1];
! 		$password   = $args[2];
  		$content_struct = $args[3];
! 		$publish     = $args[4];
  
! 		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
  		do_action('xmlrpc_call', 'metaWeblog.editPost');
  
! 		$cap = ( $publish ) ? 'publish_posts' : 'edit_posts';
! 		$error_message = __( 'Sorry, you are not allowed to publish posts on this site.' );
! 		$post_type = 'post';
! 		$page_template = '';
! 		if ( !empty( $content_struct['post_type'] ) ) {
! 			if ( $content_struct['post_type'] == 'page' ) {
! 				if ( $publish || 'publish' == $content_struct['page_status'] )
! 					$cap  = 'publish_pages';
! 				else
! 					$cap = 'edit_pages';
! 				$error_message = __( 'Sorry, you are not allowed to publish pages on this site.' );
! 				$post_type = 'page';
! 				if ( !empty( $content_struct['wp_page_template'] ) )
! 					$page_template = $content_struct['wp_page_template'];
! 			} elseif ( $content_struct['post_type'] == 'post' ) {
! 				if ( $publish || 'publish' == $content_struct['post_status'] )
! 					$cap  = 'publish_posts';
! 				else
! 					$cap = 'edit_posts';
! 				$error_message = __( 'Sorry, you are not allowed to publish posts on this site.' );
! 				$post_type = 'post';
! 			} else {
! 				// No other post_type values are allowed here
! 				return new IXR_Error( 401, __( 'Invalid post type.' ) );
! 			}
! 		} else {
! 			if ( $publish || 'publish' == $content_struct['post_status'] )
! 				$cap  = 'publish_posts';
! 			else
! 				$cap = 'edit_posts';
! 			$error_message = __( 'Sorry, you are not allowed to publish posts on this site.' );
! 			$post_type = 'post';
! 		}
  
! 		if ( !current_user_can( $cap ) )
! 			return new IXR_Error( 401, $error_message );
  
  		// Check for a valid post format if one was given
  		if ( isset( $content_struct['wp_post_format'] ) ) {
--- 3963,3997 ----
  
  		$this->escape($args);
  
! 		$post_ID        = (int) $args[0];
! 		$username       = $args[1];
! 		$password       = $args[2];
  		$content_struct = $args[3];
! 		$publish        = isset( $args[4] ) ? $args[4] : 0;
  
! 		if ( ! $user = $this->login($username, $password) )
  			return $this->error;
  
  		do_action('xmlrpc_call', 'metaWeblog.editPost');
  
! 		$postdata = wp_get_single_post( $post_ID, ARRAY_A );
  
! 		// If there is no post data for the give post id, stop
! 		// now and return an error. Other wise a new post will be
! 		// created (which was the old behavior).
! 		if ( ! $postdata || empty( $postdata[ 'ID' ] ) )
! 			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
! 
! 		if ( ! current_user_can( 'edit_post', $post_ID ) )
! 			return new IXR_Error( 401, __( 'Sorry, you do not have the right to edit this post.' ) );
! 
! 		// Use wp.editPost to edit post types other than post and page.
! 		if ( ! in_array( $postdata[ 'post_type' ], array( 'post', 'page' ) ) )
! 			return new IXR_Error( 401, __( 'Invalid post type' ) );
! 
! 		// Thwart attempt to change the post type.
! 		if ( ! empty( $content_struct[ 'post_type' ] ) && ( $content_struct['post_type'] != $postdata[ 'post_type' ] ) )
! 			return new IXR_Error( 401, __( 'The post type may not be changed.' ) );
  
  		// Check for a valid post format if one was given
  		if ( isset( $content_struct['wp_post_format'] ) ) {
***************
*** 2541,2554 ****
  			}
  		}
  
- 		$postdata = wp_get_single_post($post_ID, ARRAY_A);
- 
- 		// If there is no post data for the give post id, stop
- 		// now and return an error.  Other wise a new post will be
- 		// created (which was the old behavior).
- 		if ( empty($postdata["ID"]) )
- 			return(new IXR_Error(404, __('Invalid post ID.')));
- 
  		$this->escape($postdata);
  		extract($postdata, EXTR_SKIP);
  
--- 4001,4006 ----
***************
*** 2570,2575 ****
--- 4022,4030 ----
  		if ( isset($content_struct['wp_page_order']) )
  			$menu_order = $content_struct['wp_page_order'];
  
+ 		if ( ! empty( $content_struct['wp_page_template'] ) && 'page' == $post_type )
+ 			$page_template = $content_struct['wp_page_template'];
+ 
  		$post_author = $postdata['post_author'];
  
  		// Only set the post_author if one is set.
***************
*** 2584,2590 ****
  						return(new IXR_Error(401, __('You are not allowed to change the page author as this user.')));
  					break;
  				default:
! 					return(new IXR_Error(401, __('Invalid post type.')));
  					break;
  			}
  			$post_author = $content_struct['wp_author_id'];
--- 4039,4045 ----
  						return(new IXR_Error(401, __('You are not allowed to change the page author as this user.')));
  					break;
  				default:
! 					return(new IXR_Error(401, __('Invalid post type')));
  					break;
  			}
  			$post_author = $content_struct['wp_author_id'];
***************
*** 2647,2654 ****
  			}
  		}
  
! 		$post_title = isset( $content_struct['title'] ) ? $content_struct['title'] : null;
! 		$post_content = isset( $content_struct['description'] ) ? $content_struct['description'] : null;
  
  		$post_category = array();
  		if ( isset( $content_struct['categories'] ) ) {
--- 4102,4112 ----
  			}
  		}
  
! 		if ( isset( $content_struct['title'] ) )
! 			$post_title =  $content_struct['title'];
! 
! 		if ( isset( $content_struct['description'] ) )
! 			$post_content = $content_struct['description'];
  
  		$post_category = array();
  		if ( isset( $content_struct['categories'] ) ) {
***************
*** 2660,2666 ****
  			}
  		}
  
! 		$post_excerpt = isset( $content_struct['mt_excerpt'] ) ? $content_struct['mt_excerpt'] : null;
  		$post_more = isset( $content_struct['mt_text_more'] ) ? $content_struct['mt_text_more'] : null;
  
  		$post_status = $publish ? 'publish' : 'draft';
--- 4118,4126 ----
  			}
  		}
  
! 		if ( isset( $content_struct['mt_excerpt'] ) )
! 			$post_excerpt =  $content_struct['mt_excerpt'];
! 
  		$post_more = isset( $content_struct['mt_text_more'] ) ? $content_struct['mt_text_more'] : null;
  
  		$post_status = $publish ? 'publish' : 'draft';
***************
*** 2699,2705 ****
  
  		// Do some timestamp voodoo
  		if ( !empty( $content_struct['date_created_gmt'] ) )
! 			$dateCreated = str_replace( 'Z', '', $content_struct['date_created_gmt']->getIso() ) . 'Z'; // We know this is supposed to be GMT, so we're going to slap that Z on there by force
  		elseif ( !empty( $content_struct['dateCreated']) )
  			$dateCreated = $content_struct['dateCreated']->getIso();
  
--- 4159,4166 ----
  
  		// Do some timestamp voodoo
  		if ( !empty( $content_struct['date_created_gmt'] ) )
! 			// We know this is supposed to be GMT, so we're going to slap that Z on there by force
! 			$dateCreated = rtrim( $content_struct['date_created_gmt']->getIso(), 'Z' ) . 'Z';
  		elseif ( !empty( $content_struct['dateCreated']) )
  			$dateCreated = $content_struct['dateCreated']->getIso();
  
***************
*** 2732,2737 ****
--- 4193,4209 ----
  		if ( isset($content_struct['custom_fields']) )
  			$this->set_custom_fields($post_ID, $content_struct['custom_fields']);
  
+ 		if ( isset ( $content_struct['wp_post_thumbnail'] ) ) {
+ 			// empty value deletes, non-empty value adds/updates
+ 			if ( empty( $content_struct['wp_post_thumbnail'] ) ) {
+ 				delete_post_thumbnail( $post_ID );
+ 			} else {
+ 				if ( set_post_thumbnail( $post_ID, $content_struct['wp_post_thumbnail'] ) === false )
+ 					return new IXR_Error( 404, __( 'Invalid attachment ID.' ) );
+ 			}
+ 			unset( $content_struct['wp_post_thumbnail'] );
+ 		}
+ 
  		// Handle enclosures
  		$thisEnclosure = isset($content_struct['enclosure']) ? $content_struct['enclosure'] : null;
  		$this->add_enclosure_if_new($post_ID, $thisEnclosure);
***************
*** 2743,2749 ****
  		if ( isset( $content_struct['wp_post_format'] ) )
  			wp_set_post_terms( $post_ID, array( 'post-format-' . $content_struct['wp_post_format'] ), 'post_format' );
  
! 		logIO('O',"(MW) Edited ! ID: $post_ID");
  
  		return true;
  	}
--- 4215,4221 ----
  		if ( isset( $content_struct['wp_post_format'] ) )
  			wp_set_post_terms( $post_ID, array( 'post-format-' . $content_struct['wp_post_format'] ), 'post_format' );
  
! 		do_action( 'xmlrpc_call_success_mw_editPost', $post_ID, $args );
  
  		return true;
  	}
***************
*** 2767,2786 ****
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
  		if ( !current_user_can( 'edit_post', $post_ID ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		do_action('xmlrpc_call', 'metaWeblog.getPost');
  
- 		$postdata = wp_get_single_post($post_ID, ARRAY_A);
- 
  		if ($postdata['post_date'] != '') {
! 			$post_date = mysql2date('Ymd\TH:i:s', $postdata['post_date'], false);
! 			$post_date_gmt = mysql2date('Ymd\TH:i:s', $postdata['post_date_gmt'], false);
! 
! 			// For drafts use the GMT version of the post date
! 			if ( $postdata['post_status'] == 'draft' )
! 				$post_date_gmt = get_gmt_from_date( mysql2date( 'Y-m-d H:i:s', $postdata['post_date'] ), 'Ymd\TH:i:s' );
  
  			$categories = array();
  			$catids = wp_get_post_categories($post_ID);
--- 4239,4258 ----
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
+ 		$postdata = wp_get_single_post($post_ID, ARRAY_A);
+ 		if ( ! $postdata )
+ 			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
+ 
  		if ( !current_user_can( 'edit_post', $post_ID ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		do_action('xmlrpc_call', 'metaWeblog.getPost');
  
  		if ($postdata['post_date'] != '') {
! 			$post_date = $this->_convert_date( $postdata['post_date'] );
! 			$post_date_gmt = $this->_convert_date_gmt( $postdata['post_date_gmt'],  $postdata['post_date'] );
! 			$post_modified = $this->_convert_date( $postdata['post_modified'] );
! 			$post_modified_gmt = $this->_convert_date_gmt( $postdata['post_modified_gmt'], $postdata['post_modified'] );
  
  			$categories = array();
  			$catids = wp_get_post_categories($post_ID);
***************
*** 2823,2829 ****
  			foreach ( (array) get_post_custom($post_ID) as $key => $val) {
  				if ($key == 'enclosure') {
  					foreach ( (array) $val as $enc ) {
! 						$encdata = split("\n", $enc);
  						$enclosure['url'] = trim(htmlspecialchars($encdata[0]));
  						$enclosure['length'] = (int) trim($encdata[1]);
  						$enclosure['type'] = trim($encdata[2]);
--- 4295,4301 ----
  			foreach ( (array) get_post_custom($post_ID) as $key => $val) {
  				if ($key == 'enclosure') {
  					foreach ( (array) $val as $enc ) {
! 						$encdata = explode("\n", $enc);
  						$enclosure['url'] = trim(htmlspecialchars($encdata[0]));
  						$enclosure['length'] = (int) trim($encdata[1]);
  						$enclosure['type'] = trim($encdata[2]);
***************
*** 2833,2839 ****
  			}
  
  			$resp = array(
! 				'dateCreated' => new IXR_Date($post_date),
  				'userid' => $postdata['post_author'],
  				'postid' => $postdata['ID'],
  				'description' => $post['main'],
--- 4305,4311 ----
  			}
  
  			$resp = array(
! 				'dateCreated' => $post_date,
  				'userid' => $postdata['post_author'],
  				'postid' => $postdata['ID'],
  				'description' => $post['main'],
***************
*** 2845,2866 ****
  				'categories' => $categories,
  				'mt_excerpt' => $postdata['post_excerpt'],
  				'mt_text_more' => $post['extended'],
  				'mt_allow_comments' => $allow_comments,
  				'mt_allow_pings' => $allow_pings,
  				'mt_keywords' => $tagnames,
  				'wp_slug' => $postdata['post_name'],
  				'wp_password' => $postdata['post_password'],
  				'wp_author_id' => (string) $author->ID,
! 				'wp_author_display_name'	=> $author->display_name,
! 				'date_created_gmt' => new IXR_Date($post_date_gmt),
  				'post_status' => $postdata['post_status'],
  				'custom_fields' => $this->get_custom_fields($post_ID),
  				'wp_post_format' => $post_format,
! 				'sticky' => $sticky
  			);
  
  			if ( !empty($enclosure) ) $resp['enclosure'] = $enclosure;
  
  			return $resp;
  		} else {
  			return new IXR_Error(404, __('Sorry, no such post.'));
--- 4317,4343 ----
  				'categories' => $categories,
  				'mt_excerpt' => $postdata['post_excerpt'],
  				'mt_text_more' => $post['extended'],
+ 				'wp_more_text' => $post['more_text'],
  				'mt_allow_comments' => $allow_comments,
  				'mt_allow_pings' => $allow_pings,
  				'mt_keywords' => $tagnames,
  				'wp_slug' => $postdata['post_name'],
  				'wp_password' => $postdata['post_password'],
  				'wp_author_id' => (string) $author->ID,
! 				'wp_author_display_name' => $author->display_name,
! 				'date_created_gmt' => $post_date_gmt,
  				'post_status' => $postdata['post_status'],
  				'custom_fields' => $this->get_custom_fields($post_ID),
  				'wp_post_format' => $post_format,
! 				'sticky' => $sticky,
! 				'date_modified' => $post_modified,
! 				'date_modified_gmt' => $post_modified_gmt
  			);
  
  			if ( !empty($enclosure) ) $resp['enclosure'] = $enclosure;
  
+ 			$resp['wp_post_thumbnail'] = get_post_thumbnail_id( $postdata['ID'] );
+ 
  			return $resp;
  		} else {
  			return new IXR_Error(404, __('Sorry, no such post.'));
***************
*** 2895,2912 ****
  		$posts_list = wp_get_recent_posts( $query );
  
  		if ( !$posts_list )
! 			return array( );
  
  		foreach ($posts_list as $entry) {
  			if ( !current_user_can( 'edit_post', $entry['ID'] ) )
  				continue;
  
! 			$post_date = mysql2date('Ymd\TH:i:s', $entry['post_date'], false);
! 			$post_date_gmt = mysql2date('Ymd\TH:i:s', $entry['post_date_gmt'], false);
! 
! 			// For drafts use the GMT version of the date
! 			if ( $entry['post_status'] == 'draft' )
! 				$post_date_gmt = get_gmt_from_date( mysql2date( 'Y-m-d H:i:s', $entry['post_date'] ), 'Ymd\TH:i:s' );
  
  			$categories = array();
  			$catids = wp_get_post_categories($entry['ID']);
--- 4372,4387 ----
  		$posts_list = wp_get_recent_posts( $query );
  
  		if ( !$posts_list )
! 			return array();
  
  		foreach ($posts_list as $entry) {
  			if ( !current_user_can( 'edit_post', $entry['ID'] ) )
  				continue;
  
! 			$post_date = $this->_convert_date( $entry['post_date'] );
! 			$post_date_gmt = $this->_convert_date_gmt( $entry['post_date_gmt'], $entry['post_date'] );
! 			$post_modified = $this->_convert_date( $entry['post_modified'] );
! 			$post_modified_gmt = $this->_convert_date_gmt( $entry['post_modified_gmt'], $entry['post_modified'] );
  
  			$categories = array();
  			$catids = wp_get_post_categories($entry['ID']);
***************
*** 2943,2949 ****
  				$post_format = 'standard';
  
  			$struct[] = array(
! 				'dateCreated' => new IXR_Date($post_date),
  				'userid' => $entry['post_author'],
  				'postid' => (string) $entry['ID'],
  				'description' => $post['main'],
--- 4418,4424 ----
  				$post_format = 'standard';
  
  			$struct[] = array(
! 				'dateCreated' => $post_date,
  				'userid' => $entry['post_author'],
  				'postid' => (string) $entry['ID'],
  				'description' => $post['main'],
***************
*** 2955,2960 ****
--- 4430,4436 ----
  				'categories' => $categories,
  				'mt_excerpt' => $entry['post_excerpt'],
  				'mt_text_more' => $post['extended'],
+ 				'wp_more_text' => $post['more_text'],
  				'mt_allow_comments' => $allow_comments,
  				'mt_allow_pings' => $allow_pings,
  				'mt_keywords' => $tagnames,
***************
*** 2962,2973 ****
  				'wp_password' => $entry['post_password'],
  				'wp_author_id' => (string) $author->ID,
  				'wp_author_display_name' => $author->display_name,
! 				'date_created_gmt' => new IXR_Date($post_date_gmt),
  				'post_status' => $entry['post_status'],
  				'custom_fields' => $this->get_custom_fields($entry['ID']),
! 				'wp_post_format' => $post_format
  			);
  
  		}
  
  		$recent_posts = array();
--- 4438,4453 ----
  				'wp_password' => $entry['post_password'],
  				'wp_author_id' => (string) $author->ID,
  				'wp_author_display_name' => $author->display_name,
! 				'date_created_gmt' => $post_date_gmt,
  				'post_status' => $entry['post_status'],
  				'custom_fields' => $this->get_custom_fields($entry['ID']),
! 				'wp_post_format' => $post_format,
! 				'date_modified' => $post_modified,
! 				'date_modified_gmt' => $post_modified_gmt
  			);
  
+ 			$entry_index = count( $struct ) - 1;
+ 			$struct[ $entry_index ][ 'wp_post_thumbnail' ] = get_post_thumbnail_id( $entry['ID'] );
  		}
  
  		$recent_posts = array();
***************
*** 3045,3060 ****
  		$type = $data['type'];
  		$bits = $data['bits'];
  
- 		logIO('O', '(MW) Received '.strlen($bits).' bytes');
- 
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
  		do_action('xmlrpc_call', 'metaWeblog.newMediaObject');
  
  		if ( !current_user_can('upload_files') ) {
! 			logIO('O', '(MW) User does not have upload_files capability');
! 			$this->error = new IXR_Error(401, __('You are not allowed to upload files to this site.'));
  			return $this->error;
  		}
  
--- 4525,4537 ----
  		$type = $data['type'];
  		$bits = $data['bits'];
  
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
  		do_action('xmlrpc_call', 'metaWeblog.newMediaObject');
  
  		if ( !current_user_can('upload_files') ) {
! 			$this->error = new IXR_Error( 401, __( 'You do not have permission to upload files.' ) );
  			return $this->error;
  		}
  
***************
*** 3079,3088 ****
  			$name = "wpid{$old_file->ID}-{$filename}";
  		}
  
! 		$upload = wp_upload_bits($name, NULL, $bits);
  		if ( ! empty($upload['error']) ) {
  			$errorString = sprintf(__('Could not write file %1$s (%2$s)'), $name, $upload['error']);
- 			logIO('O', '(MW) ' . $errorString);
  			return new IXR_Error(500, $errorString);
  		}
  		// Construct the attachment array
--- 4556,4564 ----
  			$name = "wpid{$old_file->ID}-{$filename}";
  		}
  
! 		$upload = wp_upload_bits($name, null, $bits);
  		if ( ! empty($upload['error']) ) {
  			$errorString = sprintf(__('Could not write file %1$s (%2$s)'), $name, $upload['error']);
  			return new IXR_Error(500, $errorString);
  		}
  		// Construct the attachment array
***************
*** 3101,3107 ****
  		$id = wp_insert_attachment( $attachment, $upload[ 'file' ], $post_id );
  		wp_update_attachment_metadata( $id, wp_generate_attachment_metadata( $id, $upload['file'] ) );
  
! 		return apply_filters( 'wp_handle_upload', array( 'file' => $name, 'url' => $upload[ 'url' ], 'type' => $type ), 'upload' );
  	}
  
  	/* MovableType API functions
--- 4577,4591 ----
  		$id = wp_insert_attachment( $attachment, $upload[ 'file' ], $post_id );
  		wp_update_attachment_metadata( $id, wp_generate_attachment_metadata( $id, $upload['file'] ) );
  
! 		do_action( 'xmlrpc_call_success_mw_newMediaObject', $id, $args );
! 
! 		$struct = array(
! 			'id'   => strval( $id ),
! 			'file' => $name,
! 			'url'  => $upload[ 'url' ],
! 			'type' => $type
! 		);
! 		return apply_filters( 'wp_handle_upload', $struct, 'upload' );
  	}
  
  	/* MovableType API functions
***************
*** 3140,3163 ****
  			return $this->error;
  		}
  
  		foreach ($posts_list as $entry) {
  			if ( !current_user_can( 'edit_post', $entry['ID'] ) )
  				continue;
  
! 			$post_date = mysql2date('Ymd\TH:i:s', $entry['post_date'], false);
! 			$post_date_gmt = mysql2date('Ymd\TH:i:s', $entry['post_date_gmt'], false);
! 
! 			// For drafts use the GMT version of the date
! 			if ( $entry['post_status'] == 'draft' )
! 				$post_date_gmt = get_gmt_from_date( mysql2date( 'Y-m-d H:i:s', $entry['post_date'] ), 'Ymd\TH:i:s' );
  
  			$struct[] = array(
! 				'dateCreated' => new IXR_Date($post_date),
  				'userid' => $entry['post_author'],
  				'postid' => (string) $entry['ID'],
  				'title' => $entry['post_title'],
  				'post_status' => $entry['post_status'],
! 				'date_created_gmt' => new IXR_Date($post_date_gmt)
  			);
  
  		}
--- 4624,4645 ----
  			return $this->error;
  		}
  
+ 		$struct = array();
+ 
  		foreach ($posts_list as $entry) {
  			if ( !current_user_can( 'edit_post', $entry['ID'] ) )
  				continue;
  
! 			$post_date = $this->_convert_date( $entry['post_date'] );
! 			$post_date_gmt = $this->_convert_date_gmt( $entry['post_date_gmt'], $entry['post_date'] );
  
  			$struct[] = array(
! 				'dateCreated' => $post_date,
  				'userid' => $entry['post_author'],
  				'postid' => (string) $entry['ID'],
  				'title' => $entry['post_title'],
  				'post_status' => $entry['post_status'],
! 				'date_created_gmt' => $post_date_gmt
  			);
  
  		}
***************
*** 3227,3232 ****
--- 4709,4717 ----
  		if ( !$user = $this->login($username, $password) )
  			return $this->error;
  
+ 		if ( ! get_post( $post_ID ) )
+ 			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
+ 
  		if ( !current_user_can( 'edit_post', $post_ID ) )
  			return new IXR_Error( 401, __( 'Sorry, you can not edit this post.' ) );
  
***************
*** 3270,3275 ****
--- 4755,4763 ----
  
  		do_action('xmlrpc_call', 'mt.setPostCategories');
  
+ 		if ( ! get_post( $post_ID ) )
+ 			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
+ 
  		if ( !current_user_can('edit_post', $post_ID) )
  			return new IXR_Error(401, __('Sorry, you cannot edit this post.'));
  
***************
*** 3377,3387 ****
  
  		do_action('xmlrpc_call', 'mt.publishPost');
  
  		if ( !current_user_can('publish_posts') || !current_user_can('edit_post', $post_ID) )
  			return new IXR_Error(401, __('Sorry, you cannot publish this post.'));
  
- 		$postdata = wp_get_single_post($post_ID,ARRAY_A);
- 
  		$postdata['post_status'] = 'publish';
  
  		// retain old cats
--- 4865,4877 ----
  
  		do_action('xmlrpc_call', 'mt.publishPost');
  
+ 		$postdata = wp_get_single_post($post_ID, ARRAY_A);
+ 		if ( ! $postdata )
+ 			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
+ 
  		if ( !current_user_can('publish_posts') || !current_user_can('edit_post', $post_ID) )
  			return new IXR_Error(401, __('Sorry, you cannot publish this post.'));
  
  		$postdata['post_status'] = 'publish';
  
  		// retain old cats
***************
*** 3469,3477 ****
  		}
  		$post_ID = (int) $post_ID;
  
- 
- 		logIO("O","(PB) URL='$pagelinkedto' ID='$post_ID' Found='$way'");
- 
  		$post = get_post($post_ID);
  
  		if ( !$post ) // Post_ID not found
--- 4959,4964 ----
***************
*** 3613,3616 ****
  		return $pingbacks;
  	}
  }
- ?>
--- 5100,5102 ----
